/**
*	@file Rcb4BaseClass.cpp
*	@brief RCB4 base library
*	@author Kondo Kagaku Co.,Ltd.
*	@version 1.1.0
*
*	@date	2018/02/01
*	@date	2019/01/16@V1.1.0
*			EgetConfig̕sC
*			EmoveRamToComCmdSynchronizememcopy̕sΉ
*
*	@copyright &copy; Kondo Kagaku Co.,Ltd. 2019
**/
/* 
* Rcb4BaseClass.cpp
*
* Created: 2017/06/13 4:34:57
* Author: 5636m_000,T.Nobuhara
*/


#include "Rcb4BaseClass.h"



//RCB4configf[^擾 //////////////////////////////////////////////////////////
/**
* @brief RCB4̃RtBOf[^ǂݎ
* @return ǂ̃tO
* @retval true	ʐMAf[^擾
* @retval false	ʐMs
* @attention classconfigDataɒl܂
**/
///////////////////////////////////////////////////////////////////////////////////
// (configf[^擾)
bool Rcb4BaseClass::getConfig()
{
	byte	wkbuf[10];
	if(moveRamToComCmdSynchronize(ConfigRamAddress ,0x02,wkbuf) != 0xffff)
	{
		configData.byte.low = wkbuf[0];
		configData.byte.high= wkbuf[1];
		return 	true;
	}
	else
	{
		return false;
	}
}

//RCB4configf[^擾 //////////////////////////////////////////////////////////
/**
* @brief RCB4̃RtBOf[^ǂݎ
* @param[out] confData	RCB4̃RtBOf[^
* @return ǂ̃tO
* @retval true	ʐMAf[^擾
* @retval false	ʐMs
* @attention ԂlclassconfigData̒lRs[܂B(configData̒ɂ܂)
* @date 2019/01/15@confDatãAhXɃf[^Ă̂ŏC
**/
bool Rcb4BaseClass::getConfig(unsigned short *confData)
{
	if(getConfig() == false)	return	false;

	*confData = configData.word; 
	delay(100);
	return	true;
}


//Rcb4BaseClassŎgpĂ鑗Mobt@ɉ悤ƂĂȂ`FbN///////////
/**
* @brief f[^ʐMŁAMobt@ɒl悤ƂĂ邩`FbN
* @param[in] *txData	ݓ悤ƎvĂ鑗Mobt@
* @return ǂ̃tO
* @retval true	ݓ悤ƂĂobt@͉gĂȂ
* @retval false	ݓ悤ƂĂobt@͎gĂŒł
* @attention Rcb4BaseClassŎgĂ鑗Mobt@͋ʂŎgĂ̂ŁAMɕςȂmFsĂ
**/
bool Rcb4BaseClass::checkuning(byte *txData)		///f[^ʐMŁAMobt@ɒl悤ƂĂ邩`FbN
{
	return (_isSynchronize == true && txBuf == txData) ? false: true;
}


///////////////////////////////////////////////////////////////////////////////////
//comand쐬 (f[^^ƑMR}h쐬
//
// 
//COMRAMɃf[^]R}h𐶐///////////
/**
* @brief COMRAMɃf[^]R}h𐶐
* @param[out] *txData	ݓ悤ƎvĂ鑗Mobt@
* @param[in] destAddr	RCB4ɏސ擪AhX
* @param[in] destData[]	݃f[^
* @param[in] destDataSize	݃f[^
* @return Mf[^
* @retval -1	obt@ɉgĂ邩TCY249byteȏ
* @details ԒltxDatãf[^byteԂ܂̂ŁAM̂Ɏgp܂
* @details COMRCB4RAM̃f[^R}h𐶐܂
**/
int Rcb4BaseClass::moveComToRamCmd(byte *txData,int destAddr,byte destData[],int destDataSize)
{
	if(checkuning(txData) == false || destDataSize > 249)
	{
		return -1;
	}

	byte	*ptr;
	WordByte	wk;

	wk.word = destAddr;
	ptr = txData;

	*ptr++ = (byte)destDataSize + 7;		//R}h̃f[^
	*ptr++=  Move;							//moveR}h
	*ptr++=  0x02;							//COM => RAM
	*ptr++=  wk.byte[0];					//ސ擪AhX
	*ptr++=  wk.byte[1];					//
	*ptr++=  0x00;							//dl
	for(int i = 0; i < destDataSize; i++)	//f[^
	{
		*ptr++=  destData[i];
	}
	setCheckSum(txData);					//`FbNT
	
	return destDataSize + 7;
	
}


/**
* @brief COMRAMɃf[^]R}h𐶐
* @param[in] destAddr	RCB4ɏސ擪AhX
* @param[in] destData[]	݃f[^
* @param[in] destDataSize	݃f[^
* @return Mf[^
* @retval -1	obt@ɉgĂ邩TCY249byteȏ
* @details COMRCB4RAM̃f[^R}h𐶐܂
* @details ԒltxDatãf[^byteԂ܂̂ŁAM̂Ɏgp܂
* @attention R}hf[^Rcb4BaseClasstxBufɓ܂
**/
int Rcb4BaseClass::moveComToRamCmd(int destAddr,byte destData[],int destDataSize)
{
	return moveComToRamCmd(txBuf, destAddr, destData, destDataSize);
}


//RAM̏ԂCOMɓ]R}h
/**
* @brief RAM̃f[^COMɑR}h𐶐
* @param[out] *txData	ݓ悤ƎvĂ鑗Mobt@
* @param[in] scrAddr	RCB4ɏސ擪AhX
* @param[in] scrDataSize	݃f[^
* @return Mf[^
* @retval -1	obt@ɉgĂ邩TCY249byteȏ
* @details RCB4̓RAM̃f[^COMɑR}h𐶐܂
* @details ԒltxDatãf[^byteԂ܂̂ŁAM̂Ɏgp܂
**/
int Rcb4BaseClass::moveRamToComCmd(byte *txData,int scrAddr,int scrDataSize)
{
	if(checkuning(txData) == false)	return -1;

	byte	*ptr;
	WordByte	wk;

	wk.word = scrAddr;

	ptr = txData;

	*ptr++ = 0x0a;		//R}h̃f[^(̃R}h͌Œ)
	*ptr++=  Move;		//moveR}h
	*ptr++=  0x20;		//RAM => COM
	*ptr++=  0x00;		//dl(COMo)
	*ptr++=  0x00;		//dl
	*ptr++=  0x00;		//dl
	*ptr++=  wk.byte[0];		//]̃AhX
	*ptr++=  wk.byte[1];		//
	*ptr++=  (byte)scrDataSize;	//Ă炢byte

	setCheckSum(txData);		//`FbNT
	return 0x0a;

}

//RAM̏ԂCOMɓ]R}h
/**
* @brief RAM̃f[^COMɑR}h𐶐
* @param[in] scrAddr	RCB4ɏސ擪AhX
* @param[in] scrDataSize	݃f[^
* @return Mf[^
* @retval -1	obt@ɉgĂ邩TCY249byteȏ
* @details RCB4̓RAM̃f[^COMɑR}h𐶐܂
* @details ԒltxDatãf[^byteԂ܂̂ŁAM̂Ɏgp܂
* @attention R}hf[^Rcb4BaseClasstxBufɓ܂
**/
int Rcb4BaseClass::moveRamToComCmd(int scrAddr,int scrDataSize)
{
	return moveRamToComCmd(txBuf, scrAddr, scrDataSize);
}



//COM̃f[^ICSɓWJR}h
/**
* @brief COM̃f[^ICSɓWJR}h𐶐(short 2byteo[W)
* @param[out] *txData	ݓ悤ƎvĂ鑗Mobt@
* @param[in] icsNum		ICSԍ
* @param[in] offset		oCgꂽƂANZX邩
* @param[in] data		2bytẽf[^
* @return Mf[^
* @retval -1	obt@ɉgĂ邩TCY249byteȏ
* @details COMRCB4̓ICSGAɊ蓖Ăꂽf[^ɔf܂
* @details ԒltxDatãf[^byteԂ܂̂ŁAM̂Ɏgp܂
**/
int Rcb4BaseClass::moveComToDeviceCmd (byte *txData,byte icsNum,byte offset,int data)
{
	if(checkuning(txData) == false)	return -1;

	byte	*ptr;
	WordByte	wk;

	ptr = txData;
	wk.word = data;
				
	*ptr++ = 0x09;		//R}h̃f[^(̃R}h͌Œ)
	*ptr++=  Move;		//moveR}h
	*ptr++=  0x12;		//com => Device
	*ptr++=  offset;	//foCX̐擪ǂꂾĂ邩
	*ptr++=  icsNum;	//ICSԍ
	*ptr++=  0x00;		//dl
	*ptr++=  wk.byte[0];	//f[^
	*ptr++=  wk.byte[1];	//
	setCheckSum(txData);	//`FbNT
	return 0x09;

}



/**
* @brief COM̃f[^ICSɓWJR}h𐶐(short 2byteo[W)
* @param[out] *txData	ݓ悤ƎvĂ鑗Mobt@
* @param[in] idNum		T[{IDԍ
* @param[in] sioNum		SIO(SioNum)̔ԍ
* @param[in] offset		oCgꂽƂANZX邩
* @param[in] data		2bytẽf[^
* @return Mf[^
* @retval -1	obt@ɉgĂ邩TCY249byteȏ
* @details COMRCB4̓ICSGAɊ蓖Ăꂽf[^ɔf܂
* @details ԒltxDatãf[^byteԂ܂̂ŁAM̂Ɏgp܂
**/
int Rcb4BaseClass::moveComToDeviceCmd (byte *txData,byte idNum,byte sioNum,byte offset,int data)
{
	return moveComToDeviceCmd (txData, icsNum2id(idNum, sioNum), offset, data);
}



/**
* @brief COM̃f[^ICSɓWJR}h𐶐(short 2byteo[W)
* @param[in] icsNum		ICSԍ
* @param[in] offset		oCgꂽƂANZX邩
* @param[in] data		2bytẽf[^
* @return Mf[^
* @retval -1	obt@ɉgĂ邩TCY249byteȏ
* @details COMRCB4̓ICSGAɊ蓖Ăꂽf[^ɔf܂
* @details ԒltxDatãf[^byteԂ܂̂ŁAM̂Ɏgp܂
* @attention R}hf[^Rcb4BaseClasstxBufɓ܂
**/
int Rcb4BaseClass::moveComToDeviceCmd (byte icsNum,byte offset,int data)
{
	return moveComToDeviceCmd (txBuf, icsNum, offset, data);
}



/**
* @brief COM̃f[^ICSɓWJR}h𐶐(short 2byteo[W)
* @param[in] idNum		T[{IDԍ
* @param[in] sioNum		SIO(SioNum)̔ԍ
* @param[in] offset		oCgꂽƂANZX邩
* @param[in] data		2bytẽf[^
* @return Mf[^
* @retval -1	obt@ɉgĂ邩TCY249byteȏ
* @details COMRCB4̓ICSGAɊ蓖Ăꂽf[^ɔf܂
* @details ԒltxDatãf[^byteԂ܂̂ŁAM̂Ɏgp܂
* @attention R}hf[^Rcb4BaseClasstxBufɓ܂
**/
int Rcb4BaseClass::moveComToDeviceCmd (byte idNum,byte sioNum,byte offset,int data)
{
	return moveComToDeviceCmd (txBuf, icsNum2id(idNum, sioNum), offset, data);
}




//ICS̃f[^COMɓ]R}h)
/**
* @brief ICS̃f[^COMɓ]R}h𐶐
* @param[out] *txData	ݓ悤ƎvĂ鑗Mobt@
* @param[in] icsNum		ICSԍ
* @param[in] offset		oCgꂽƂANZX邩
* @param[in] dataSize	擾f[^
* @return Mf[^
* @retval -1	obt@ɉgĂ邩TCY249byteȏ
* @details RCB4ICSGAɊ蓖Ăꂽf[^COMɓ]R}h𐶐܂
* @details ԒltxDatãf[^byteԂ܂̂ŁAM̂Ɏgp܂
**/
int Rcb4BaseClass::moveDeviceToComCmd(byte *txData,byte icsNum,byte offset,byte dataSize)
{
	if(checkuning(txData) == false)	return -1;

	byte	*ptr;

	ptr = txData;

	*ptr++ = 0x0a;			//R}h̃f[^(̃R}h͌Œ)
	*ptr++ = Move;			//moveR}h
	*ptr++ = 0x21;			//Device => com 
	*ptr++ = offset;		//foCX̐擪ǂꂾĂ邩
	*ptr++ = 0x00;			//dl(COMo)
	*ptr++ = 0x00;			//dl
	*ptr++ = 0x00;			//dl
	*ptr++ = icsNum;		//ICSԍ
	*ptr++ = dataSize;		//oCg炤
	setCheckSum(txData);	//`FbNT	
	return 0x0a;

}



/**
* @brief ICS̃f[^COMɓ]R}h𐶐
* @param[out] *txData	ݓ悤ƎvĂ鑗Mobt@
* @param[in] idNum		T[{IDԍ
* @param[in] sioNum		SIO(SioNum)̔ԍ
* @param[in] offset		oCgꂽƂANZX邩
* @param[in] dataSize	擾f[^
* @return Mf[^
* @retval -1	obt@ɉgĂ邩TCY249byteȏ
* @details RCB4ICSGAɊ蓖Ăꂽf[^COMɓ]R}h𐶐܂
* @details ԒltxDatãf[^byteԂ܂̂ŁAM̂Ɏgp܂
**/
int Rcb4BaseClass::moveDeviceToComCmd(byte *txData,byte idNum,byte sioNum,byte offset,byte dataSize)
{
	return  moveDeviceToComCmd(txData, icsNum2id(idNum, sioNum), offset, dataSize);
}



/**
* @brief ICS̃f[^COMɓ]R}h𐶐
* @param[in] icsNum		ICSԍ
* @param[in] offset		oCgꂽƂANZX邩
* @param[in] dataSize	擾f[^
* @return Mf[^
* @retval -1	obt@ɉgĂ邩TCY249byteȏ
* @details RCB4ICSGAɊ蓖Ăꂽf[^COMɓ]R}h𐶐܂
* @details ԒltxDatãf[^byteԂ܂̂ŁAM̂Ɏgp܂
* @attention R}hf[^Rcb4BaseClasstxBufɓ܂
**/
int Rcb4BaseClass::moveDeviceToComCmd(byte icsNum, byte offset, byte dataSize)
{
	return  moveDeviceToComCmd(txBuf, icsNum, offset, dataSize);
}

/**
* @brief ICS̃f[^COMɓ]R}h𐶐
* @param[in] idNum		T[{IDԍ
* @param[in] sioNum		SIO(SioNum)̔ԍ
* @param[in] offset		oCgꂽƂANZX邩
* @param[in] dataSize	擾f[^
* @return Mf[^
* @retval -1	obt@ɉgĂ邩TCY249byteȏ
* @details RCB4ICSGAɊ蓖Ăꂽf[^COMɓ]R}h𐶐܂
* @details ԒltxDatãf[^byteԂ܂̂ŁAM̂Ɏgp܂
* @attention R}hf[^Rcb4BaseClasstxBufɓ܂
**/
int Rcb4BaseClass::moveDeviceToComCmd(byte idNum,byte sioNum, byte offset, byte dataSize)
{
	return  moveDeviceToComCmd(txBuf, icsNum2id(idNum, sioNum), offset, dataSize);
}




//w肵AhXɃWv
/**
* @brief w肵AhXɃWv(CALL)R}h𐶐܂
* @param[out] *txData	ݓ悤ƎvĂ鑗Mobt@
* @param[in] romAddr		WvAhX
* @return Mf[^
* @retval -1	obt@ɉgĂ邩TCY249byteȏ
* @details ԒltxDatãf[^byteԂ܂̂ŁAM̂Ɏgp܂
* @details ROM̎wAhXɃWv閽߂𐶐܂B
* @details Call߂Ȃ̂ŁAI猳̏ꏊɖ߂܂B
**/
int Rcb4BaseClass::callCmd(byte *txData,long romAddr)
{
	if(checkuning(txData) == false)	return -1;

	byte	*ptr;
	DwordByte	wk;
	
	wk.dword = (uint32_t)romAddr;
	ptr = txData;

	*ptr++ = 0x07;				//R}h̃f[^(͌Œ)
	*ptr++ = Call;				//CallR}h
	*ptr++ = wk.byte[0];		//AhX
	*ptr++ = wk.byte[1];
	*ptr++ = wk.byte[2];
	*ptr++ = 0x00;				//荀ځ@=>Ŕ
	setCheckSum(txData);		//`FbNT
	return 0x07;

}



/**
* @brief w肵AhXɃWv(CALL)R}h𐶐܂
* @param[in] romAddr		WvAhX
* @return Mf[^
* @retval -1	obt@ɉgĂ邩TCY249byteȏ
* @details ROM̎wAhXɃWv閽߂𐶐܂B
* @details Call߂Ȃ̂ŁAI猳̏ꏊɖ߂܂B
* @details ԒltxDatãf[^byteԂ܂̂ŁAM̂Ɏgp܂
* @attention R}hf[^Rcb4BaseClasstxBufɓ܂
**/
int Rcb4BaseClass::callCmd(long romAddr)
{
	return callCmd(txBuf, romAddr);
}





//T[{1)
/**
* @brief w肵T[{[^1R}h쐬܂
* @param[out] *txData	ݓ悤ƎvĂ鑗Mobt@
* @param[in] servoData	ƂĂT[{1܂Ƃ܂ɂ^
* @param[in] frame	t[
* @return Mf[^
* @retval -1	obt@ɉgĂ邩TCY249byteȏ
* @details 1T[{𓮂܂B
* @details ServoData^ɂ́AT[{[^IDȊOɂSIOƓ|WṼf[^܂
* @details ԒltxDatãf[^byteԂ܂̂ŁAM̂Ɏgp܂
**/	
int Rcb4BaseClass::runSingleServoCmd (byte *txData,ServoData servoData,byte frame)
{
	return runSingleServoCmd (txData, servoData.Id, servoData.Sio, servoData.Data, frame);
}


/**
* @brief w肵T[{[^1R}h쐬܂
* @param[in] servoData	ƂĂT[{1܂Ƃ܂ɂ^
* @param[in] frame	t[
* @return Mf[^
* @retval -1	obt@ɉgĂ邩TCY249byteȏ
* @details 1T[{𓮂܂B
* @details ServoData^ɂ́AT[{[^IDȊOɂSIOƓ|WṼf[^܂
* @details ԒltxDatãf[^byteԂ܂̂ŁAM̂Ɏgp܂
* @attention R}hf[^Rcb4BaseClasstxBufɓ܂
**/	
int Rcb4BaseClass::runSingleServoCmd (ServoData servoData,byte frame)
{
	return runSingleServoCmd (txBuf, servoData.Id, servoData.Sio, servoData.Data, frame);
}



/**
* @brief w肵T[{[^1R}h쐬܂
* @param[out] *txData	ݓ悤ƎvĂ鑗Mobt@
* @param[in] idNum	T[{[^IDԍ
* @param[in] sioNum	ڑĂSIO(SioNum)̔ԍ
* @param[in] pos	T[{[^̃|WVf[^(ڕWl)
* @param[in] frame	t[
* @return Mf[^
* @retval -1	obt@ɉgĂ邩TCY249byteȏ
* @details 1T[{𓮂܂B
* @details ԒltxDatãf[^byteԂ܂̂ŁAM̂Ɏgp܂
**/	
int Rcb4BaseClass::runSingleServoCmd (byte *txData,byte idNum,byte sioNum,int pos,byte frame)
{
	if(checkuning(txData) == false)	return -1;

	byte	*ptr;
	WordByte wk;

	ptr = txData;
	wk.word = pos;
	
	*ptr++ = 0x07;						//R}h̃f[^(͌Œ)
	*ptr++ = SingleServo;				//1T[{𓮂߂̃R}h
	*ptr++ = icsNum2id(idNum, sioNum);	//ICSԍ
	*ptr++ = frame;						//t[
	*ptr++=  wk.byte[0];				//|WVf[^
	*ptr++=  wk.byte[1];
	setCheckSum(txData);				//`FbNT
	return 0x07;
}

/**
* @brief w肵T[{[^1R}h쐬܂
* @param[in] idNum	T[{[^IDԍ
* @param[in] sioNum	ڑĂSIO(SioNum)̔ԍ
* @param[in] pos	T[{[^̃|WVf[^(ڕWl)
* @param[in] frame	t[
* @return Mf[^
* @retval -1	obt@ɉgĂ邩TCY249byteȏ
* @details 1T[{𓮂܂B
* @details ԒltxDatãf[^byteԂ܂̂ŁAM̂Ɏgp܂
* @attention R}hf[^Rcb4BaseClasstxBufɓ܂
**/	
int Rcb4BaseClass::runSingleServoCmd (byte idNum,byte sioNum,int pos,byte frame)
{
	return runSingleServoCmd (txBuf, idNum, sioNum, pos, frame);
}


/**
* @brief T[{[^ɃANZXƂɃR}hŁu삳T[{̎wv쐬
* @param[in] servoDatas[]	ANZXT[{̃f[^̔z
* @param[in] servoCount	ANZXT[{̃f[^̔z(T[{̐)
* @return u삳T[{̎wṽf[^
* @details u삳T[{̎wvɂ1bitԂɓ(tO)𗧂ĂĂ܂
**/	
int64_t	Rcb4BaseClass::setServoNo (ServoData servoDatas[],byte servoCount)
{
	byte	no;
	int64_t	ret = 0;
	for(int i = 0; i < servoCount ; i++)
	{
		no = icsNum2id(servoDatas[i].Id, servoDatas[i].Sio);
		int64_t sf = 0x1;
		ret |=  (sf << no);
	}

	return ret;
}


///
///	T[{̃f[^\[ĝƂĂT[{f[^̕ԋp
///
/**
* @brief T[{[^ɃANZXƂɃT[{̏Ԃ̎w肪̂Ń\[g
* @param[in,out] servoDatas[]	ANZXT[{̃f[^̔z
* @param[in] servoCount	ANZXT[{̃f[^̔z(T[{̐)
* @return u삳T[{̎wṽf[^
* @retval true \[g
* @retval false	f[^sICSԍ蓖Ă悤ƂƂ
* @details T[{[^𕡐AԂɕłKv̂ł̃f[^\[g܂
* @attention servoDataŝ̂\[ĝŁAg܂B
* @attention f[^ێĂꍇ́ARs[ĂĂgpĂ
**/	
bool Rcb4BaseClass::sortServoDatas(ServoData servoDatas[],byte servoCount)
{
	const int servoMaxCount = 36;
	
	if(servoCount > servoMaxCount)	//T[{̌ȏ゠悤Ȃ甲
	{
		return false;
	}
	
	ServoData bufServoDatas[servoMaxCount];//ꎞIɕۑobt@
	
	int i;		//[vp
	
	for(i = 0;i<servoMaxCount;i++)		//Ƃ肠0xFFŏ
	{
		bufServoDatas[i].Id = 0xFF;
		bufServoDatas[i].Sio = 0xFF;	
	}
	
	for(i = 0;i<servoCount;i++)//T[{̌肩AYzɃf[^Ă
	{
		byte sioNum =  icsNum2id(servoDatas[i].Id,servoDatas[i].Sio);	//ICSԍvZ
		
		if(sioNum > servoMaxCount)		//ICSԍςȐɂȂꍇ͔
		{
			return false;
		}
		
		//Ă͂܂ƂɃf[^
		bufServoDatas[sioNum].Id = servoDatas[i].Id;
		bufServoDatas[sioNum].Sio = servoDatas[i].Sio;
		bufServoDatas[sioNum].Data = servoDatas[i].Data;
		
	}
	
	byte j = 0;
	
	for(i = 0;i<servoMaxCount;i++)		//Ă͂܂鏇Ԃ
	{
		if(bufServoDatas[i].Id != 0xFF)		//Ԃɉ񂵂Ăăf[^ꍇ
		{
			//l
			servoDatas[j].Id = bufServoDatas[i].Id;
			servoDatas[j].Sio = bufServoDatas[i].Sio;
			servoDatas[j].Data = bufServoDatas[i].Data;
			
			j++;	//ɐi߂
			
			if(j >= servoCount)	//T[{f[^I甲
			{
				break;
			}
		}	
	}
	
	return true;
	
}


//̃T[{𓮂
/**
* @brief w肵T[{[^𕡐R}h̐
* @param[out] *txData	ݓ悤ƎvĂ鑗Mobt@
* @param[in] servoDatas[]	ANZXT[{̃f[^̔z
* @param[in] servoCount	ANZXT[{̃f[^̔z(T[{̐)
* @param[in] frame	t[
* @return Mf[^
* @retval -1	obt@ɉgĂ邩TCY249byteȏ
* @details T[{[^𓮂R}h𐶐܂B
* @details ԒltxDatãf[^byteԂ܂̂ŁAM̂Ɏgp܂
* @attention ServoDatadataɂ̓|WVf[^܂
**/	
int Rcb4BaseClass::runConstFrameServoCmd (byte *txData,ServoData servoDatas[],byte servoCount,byte frame)
{

	if(checkuning(txData) == false)	return -1;	

	//̓f[^ύXĂ܂̂ŁARs[Ă
	ServoData sDataBuf[servoCount];
	memcpy(sDataBuf,servoDatas , sizeof(ServoData)*servoCount);
	
	byte	*ptr;
	QwordByte wk;

	ptr = txData;

	wk.qword = setServoNo (sDataBuf, servoCount);		//u삳T[{̎wvvZĂ
	
	*ptr++ = servoCount * 2 + 9;						//CɈԍŏMf[^
	*ptr++ = ConstFrameServo;							//T[{𓮂R}h
	*ptr++ = wk.byte[0];								//u삳T[{̎wv
	*ptr++ = wk.byte[1];
	*ptr++ = wk.byte[2];
	*ptr++ = wk.byte[3];
	*ptr++ = wk.byte[4];
	*ptr++ = frame;										//t[
	
	if(sortServoDatas(sDataBuf, servoCount) == false)		//T[{̃f[^Ԃɕבւ
	{
		return -1;
	}


	
	for(int i = 0; i < servoCount ; i++)	//T[{̃f[^ԂɓĂ
	{
		wk.word[0] = sDataBuf[i].Data;
		*ptr++=  wk.byte[0];
		*ptr++=  wk.byte[1];
	}
	
	setCheckSum(txData);		//Ō̓`FbNT
	
	return servoCount * 2 + 9;
	
}


/**
* @brief w肵T[{[^𕡐R}h̐
* @param[in] servoDatas[]	ANZXT[{̃f[^̔z
* @param[in] servoCount	ANZXT[{̃f[^̔z(T[{̐)
* @param[in] frame	t[
* @return Mf[^
* @retval -1	obt@ɉgĂ邩TCY249byteȏ
* @details T[{[^𓮂R}h𐶐܂B
* @details ԒltxDatãf[^byteԂ܂̂ŁAM̂Ɏgp܂
* @attention ServoDatadataɂ̓|WVf[^܂
* @attention R}hf[^Rcb4BaseClasstxBufɓ܂
**/	
int Rcb4BaseClass::runConstFrameServoCmd (ServoData servoDatas[],byte servoCount,byte frame)
{
	return runConstFrameServoCmd (txBuf, servoDatas, servoCount, frame);
}




//xɕT[{̃p[^ύX)
/**
* @brief w肵T[{[^𕡐p[^ςR}h̐
* @param[out] *txData	ݓ悤ƎvĂ鑗Mobt@
* @param[in] servoParameter (Stretch:1 Speed:2)
* @param[in] servoDatas[]	ANZXT[{̃f[^̔z
* @param[in] servoCount	ANZXT[{̃f[^̔z(T[{̐)
* @return Mf[^
* @retval -1	obt@ɉgĂ邩TCY249byteȏ
* @details T[{[^𓮂R}h𐶐܂B
* @details ԒltxDatãf[^byteԂ܂̂ŁAM̂Ɏgp܂
* @attention ServoDatadataɂ̓Xgb`Xs[hf[^܂(Max 127)
**/	
int Rcb4BaseClass::setParametersBaseCmd (byte *txData, byte servoParameter,ServoData servoDatas[],byte servoCount)
{
	if(checkuning(txData) == false)	return -1;

	
	//̓f[^ύXĂ܂̂ŁARs[Ă
	ServoData sDataBuf[servoCount];
	memcpy(sDataBuf,servoDatas , sizeof(ServoData)*servoCount);


	byte	*ptr;
	QwordByte wk;

	ptr = txData;

	if(sortServoDatas(sDataBuf, servoCount) == false)		//Rs[f[^̓\[gĂ
	{
		return -1;
	}

	wk.qword = setServoNo (sDataBuf, servoCount);		//u삳T[{̎wvvZĂ

	*ptr++ = servoCount + 9;		//R}h̃f[^
	*ptr++ = ServoParam;			//p[^ύXR}h
	*ptr++ = wk.byte[0];			//u삳T[{̎wv
	*ptr++ = wk.byte[1];			
	*ptr++ = wk.byte[2];
	*ptr++ = wk.byte[3];
	*ptr++ = wk.byte[4];
	*ptr++ = servoParameter;		//(Stretch:1 Speed:2)
	for(int i = 0; i < servoCount ; i++)				//\[gT[{̃f[^
	{
		*ptr++=  (byte)( sDataBuf[i].Data & 0x00ff);
	}
	setCheckSum(txData);
	return servoCount + 9;
}



//xɕT[{̃p[^ύX)
/**
* @brief w肵T[{[^𕡐p[^ςR}h̐
* @param[in] servoParameter (Stretch:1 Speed:2)
* @param[in] servoDatas[]	ANZXT[{̃f[^̔z
* @param[in] servoCount	ANZXT[{̃f[^̔z(T[{̐)
* @return Mf[^
* @retval -1	obt@ɉgĂ邩TCY249byteȏ
* @details T[{[^𓮂R}h𐶐܂B
* @details ԒltxDatãf[^byteԂ܂̂ŁAM̂Ɏgp܂
* @attention ServoDatadataɂ̓Xgb`Xs[hf[^܂(Max 127)
* @attention R}hf[^Rcb4BaseClasstxBufɓ܂
**/	
int Rcb4BaseClass::setParametersBaseCmd (byte servoParameter,ServoData servoDatas[],byte servoCount)
{
	return	setParametersBaseCmd (txBuf, servoParameter, servoDatas, servoCount);
}



//xɃT[{[^̃Xs[hw肷
/**
* @brief w肵T[{[^𕡐Xs[hςR}h̐
* @param[out] *txData	ݓ悤ƎvĂ鑗Mobt@
* @param[in] servoDatas[]	ANZXT[{̃f[^̔z
* @param[in] servoCount	ANZXT[{̃f[^̔z(T[{̐)
* @return Mf[^
* @retval -1	obt@ɉgĂ邩TCY249byteȏ
* @details T[{[^𓮂R}h𐶐܂B
* @details ԒltxDatãf[^byteԂ܂̂ŁAM̂Ɏgp܂
* @attention ServoDatadataɂ̓Xs[hf[^܂(Max 127)
**/	
int Rcb4BaseClass::setSpeedCmd (byte *txData,ServoData servoDatas[],byte servoCount)
{
	return	setParametersBaseCmd (txData, 0x02, servoDatas, servoCount);
}



/**
* @brief w肵T[{[^𕡐Xs[hςR}h̐

* @param[in] servoDatas[]	ANZXT[{̃f[^̔z
* @param[in] servoCount	ANZXT[{̃f[^̔z(T[{̐)
* @return Mf[^
* @retval -1	obt@ɉgĂ邩TCY249byteȏ
* @details T[{[^𓮂R}h𐶐܂B
* @details ԒltxDatãf[^byteԂ܂̂ŁAM̂Ɏgp܂
* @attention ServoDatadataɂ̓Xs[hf[^܂(Max 127)
* @attention R}hf[^Rcb4BaseClasstxBufɓ܂
**/	
int Rcb4BaseClass::setSpeedCmd (ServoData servoDatas[],byte servoCount)
{
	return	setParametersBaseCmd (txBuf, 0x02, servoDatas, servoCount);
}



//(xɃT[{[^̃Xgb`w肷)
/**
* @brief w肵T[{[^𕡐Xgb`ςR}h̐
* @param[out] *txData	ݓ悤ƎvĂ鑗Mobt@
* @param[in] servoDatas[]	ANZXT[{̃f[^̔z
* @param[in] servoCount	ANZXT[{̃f[^̔z(T[{̐)
* @return Mf[^
* @retval -1	obt@ɉgĂ邩TCY249byteȏ
* @details T[{[^𓮂R}h𐶐܂B
* @details ԒltxDatãf[^byteԂ܂̂ŁAM̂Ɏgp܂
* @attention ServoDatadataɂ̓Xgb`f[^܂(Max 127)
**/	
int Rcb4BaseClass::setStretchCmd (byte *txData,ServoData servoDatas[],byte servoCount)
{
	return	setParametersBaseCmd (txData, 0x01, servoDatas, servoCount);
}



/**
* @brief w肵T[{[^𕡐Xgb`ςR}h̐
* @param[in] servoDatas[]	ANZXT[{̃f[^̔z
* @param[in] servoCount	ANZXT[{̃f[^̔z(T[{̐)
* @return Mf[^
* @retval -1	obt@ɉgĂ邩TCY249byteȏ
* @details T[{[^𓮂R}h𐶐܂B
* @details ԒltxDatãf[^byteԂ܂̂ŁAM̂Ɏgp܂
* @attention ServoDatadataɂ̓Xgb`f[^܂(Max 127)
* @attention R}hf[^Rcb4BaseClasstxBufɓ܂
**/	
int Rcb4BaseClass::setStretchCmd (ServoData servoDatas[],byte servoCount)
{
	return	setParametersBaseCmd (txBuf, 0x01, servoDatas, servoCount);
}

//ackԂR}h̍쐬
/**
* @brief ackR}h̐
* @param[out] *txData	ݓ悤ƎvĂ鑗Mobt@
* @return Mf[^
* @details ACK̃R}h𐶐
**/	
int Rcb4BaseClass::acknowledgeCmd (byte *txData)
{
	byte	*ptr;
	ptr = txData;

	*ptr++ = 0x04;				//R}h̃f[^(̃R}h͌Œ)
	*ptr++ = AckCheck;			//ACKR}h
	*ptr++ = Ack;				//ACK
	setCheckSum(txData);		//`FbNT
	return	0x04;
}

/**
* @brief ackR}h̐
* @return Mf[^
* @details ACK̃R}h𐶐
* @attention R}hf[^Rcb4BaseClasstxBufɓ܂
**/	
int Rcb4BaseClass::acknowledgeCmd ()
{
	return acknowledgeCmd(txBuf);
}

//////////////////////////////////////////////////////////////////////////////////////////
//ʐM֌Wi̓C^[tFCXNXj

//ۂɑMs
//bool Rcb4BaseClass::synchronize(byte txBuf[],byte txLen,byte rxBuf[],byte rxLen)
//{
//
//	isSynchronize = true;
//	if (rcbHardSerial != nullptr)
//	{
//
//		isSynchronize = true;
//		rcbHardSerial->flush();
//
//		for(byte i = 0; i < txLen; i++)
//		{
//			rcbHardSerial->write(txBuf[i]);
//	}
//
//		rcbHardSerial->setTimeout(g_timeout);
//		if(rcbHardSerial->readBytes(rxBuf,rxLen) == rxLen)
//		{
//			isSynchronize = false;
//			return checkReverceCmd(rxBuf,txBuf[1]);
//	}
//		else
//		{//ѱ
//			isSynchronize = false;
//			return	false;
//	}
//	}
//	else
//	{
//		return false;
//
//	}
//
//	return true;
//}
//



//ack𑗂ĂȂĂ邩mF
/**
* @brief ackR}h𑗐M
* @return ACKR}h㍇۔
* @retval False R}hԂĂȂNCKԂĂƂ
* @details ACK̃R}h𑗐M
* @attention R}hf[^Rcb4BaseClasstxBufɓ܂
**/	
bool Rcb4BaseClass::checkAcknowledge()
{
	bool checkFlag = true; 
		
	acknowledgeCmd (txBuf);		//ACKR}h̐
	
	checkFlag = synchronize(txBuf, txBuf[0], rxBuf, 4);		//R}h̑M
	
	if( false == checkFlag || rxBuf[2] == Nack)				//۔
	{
		return false;
	}
	else					//ȂꍇtrueԂ
	{
		return true;
	}
}



//////////////////////////////////////////////////////////////////////////
//`FbNTvŽvZ
/**
* @brief R}h̃`FbNTvZ܂
* @param[in] dataBytes[]	R}hf[^
* @return R}h̃`FbNT
* @details R}h̃`FbNTvZ܂
* @attention R}h̐擪ɂ̓R}h̃f[^Ă܂
**/	
byte	Rcb4BaseClass::CheckSum(byte dataBytes[])
{
	byte sum = 0;
	for(int i = 0; i < dataBytes[0] - 1; i++ )
	{
		sum += dataBytes[i];
	}
	return sum;
}



//R}h̃`FbNTvZ)
/**
* @brief R}h̃`FbNTvZAŌɂ܂
* @param[in,out] dataBytes[]	R}hf[^
* @return ꂽǂ̔
* @retval False R}h̐擪0
* @details R}h̃`FbNTvZAŌɑ܂
* @attention R}h̐擪ɂ̓R}h̃f[^Ă܂
**/	
bool Rcb4BaseClass::setCheckSum(byte dataBytes[])
{
	if(dataBytes[0] == 0)
	{
		return false;
	}
	else
	{
		dataBytes[dataBytes[0] -1 ] = CheckSum(dataBytes); 
		return true;
	}
}



//`FbNTĂ邩mF
/**
* @brief ĂR}h̃`FbNTĂ邩mF܂
* @param[in] dataBytes[]	R}hf[^
* @return `FbNT̔
* @retval False `FbNTԈĂƂAf[^0
* @details ĂR}h̃`FbNTĂ邩mF܂
* @attention R}h̐擪ɂ̓f[^Ă܂
**/	
bool Rcb4BaseClass::checkCheckSum(byte dataBytes[])
{
	if(dataBytes[0] == 0)
	{
		return false;
	}
	else
	{
		if(dataBytes[dataBytes[0] -1 ] == CheckSum(dataBytes))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
}


//R}hŒĂ邩mF)
/**
* @brief ԐMf[^ȈՓI`FbN܂
* @param[in] dataBytes[]	ԐMf[^z
* @param[in] cmd			MR}h
* @return ԐMf[^̔
* @retval False `FbNTԈĂƂA2byteڂMR}hƈĂƂ
* @details ԐMf[^̊ȈՃ`FbN܂
		 ԐMf[^̃`FbNTуR}h̃`FbN
* @attention R}h̐擪ɂ̓f[^Ă܂
**/	
bool Rcb4BaseClass::checkReverceCmd(byte dataBytes[],byte cmd)
{

//	const	byte cnmtbl[8] = {Move,	Jump, Call,	SingleServo, ConstFrameServo,ServoParam,AckCheck,None};	//L
	if(checkCheckSum(dataBytes) == true && dataBytes[1] == cmd)
	{
		return true;
	}
	else
	{
		return false;
	}
}

//
//	moveRamToComCmdf[^M܂ł̊֐
//
/**
* @brief MoveR}hRAM̃f[^COMɓ]܂
* @param[in] scrAddr	擾RAMf[^̐擪AhX
* @param[in] scrDataSize	擾RAM̃f[^
* @param[out] rxDara[]		Mf[^(RAM̃f[^̂)
* @return ԐMf[^̃f[^
* @retval -1 (0xFFFF) Ms
* @details RAMw肵擪AhXw肵f[^̃f[^COMɓ]܂
* @note Ԃl̓R}h܂܂Ȃf[^ɂȂ܂B
* @date 2019/01/16 rxBuf̐擪AhXƂmemcopysƗ\ʃf[^Ō듮삷̂forŃf[^}悤ɕύX
**/	
unsigned short Rcb4BaseClass::moveRamToComCmdSynchronize(int scrAddr,byte scrDataSize,byte	rxDara[])
{	
	
	if(	moveRamToComCmd(scrAddr ,scrDataSize) == -1)	return 0xffff;



	if(synchronize(txBuf, txBuf[0], rxBuf, scrDataSize + 3) == true)
	{
		//2019/01/16 memcopyrxBuf[0]ɗ\ʃf[^ꍇ̂ŁAforɕύX
		for(int i = 0;i<scrDataSize;i++)
		{
			rxDara[i] = rxBuf[i+2];
		}
		
		return scrDataSize;
		
		return 0xffff;
	}
	else
	{
	
		return 0xffff;
	}
}


//
//	moveComToRamCmdACKM܂ł̊֐
//
/**
* @brief MoveR}hRAM̃f[^COMɓ]܂
* @param[in] scrAddr	擾RAMf[^̐擪AhX
* @param[in] destData[]	Mf[^z(PɃf[^̂)
* @param[out] destDataSize	Mf[^TCY(PɃf[^̂)
* @return ʐM蓙
* @retval False Ms
* @details COMRAM̎w肵AhXɃf[^݂܂
**/	
bool	Rcb4BaseClass::moveComToRamCmdSynchronize(int scrAddr,byte destData[],int destDataSize)
{

	if(	moveComToRamCmd(scrAddr ,destData, destDataSize) == -1)	return false;	
	
	if(synchronize(txBuf, txBuf[0], rxBuf, 4) == true)
	{			
		return rxBuf[2] == Ack ?  true: false;
	}
	else
	{
		return false;
	}
}

//
//M`bj
/**
* @brief R}h𑗂āAACKԂĂ邩mF
* @param[in] *txData	Mf[^
* @return ʐM蓙
* @retval False Ms
* @details R}h𑗂āAACKԂĂ邩mF
* @note txData̐擪f[^ɂ͑Mf[^̃f[^Ă܂
**/	
bool	Rcb4BaseClass::SynchronizeAck(byte	*txData)
{
	if(synchronize(txData, *txData, rxBuf, 4) == true)
	{
		return rxBuf[2] == Ack ?  true: false;
	}
	else
	{
		return false;
	}
}




//////////////////////////////////////////////////////////////////////////////////////////
//PIO֌W
//PIǑ݂̏Ԃ擾
/**
* @brief ݂PIȌԂ擾܂
* @return ݂PIȌ(2byte܂߂ׂ)
* @retval -1(0xFFFF) ʐMs
* @details Move߂gČ݂PIOHL̏Ԃ擾܂
* @attention 1bitłȂ̂Œ
**/	
unsigned short Rcb4BaseClass::getPio()
{
	byte	wkbuf[10];
	if(moveRamToComCmdSynchronize(PioAddress ,0x02,wkbuf) != 0xffff)
	{
		WordByte wk;
		wk.byte[0] = wkbuf[0];
		wk.byte[1] = wkbuf[1];

		wk.word &= 0x03FF;		//Ȃbit̓}XN

		return 	wk.word;	
	}
	else
	{
		return 0xffff;
	}
}

//PIȌԂύX)
/**
* @brief ݂PIȌԂύX܂
* @param[in] pioData	PIOŜ̃f[^
* @return ʐMǂ
* @retval False ʐMs
* @details Move߂gČ݂PIOHL̏Ԃɂ܂
* @attention 1bitύXłȂ̂Œ
**/	
bool Rcb4BaseClass::setPio (unsigned short pioData)
{
	return moveComToRamCmdSynchronize(PioAddress, (byte*)&pioData,2);
}

//PIO̓o͂擾
/**
* @brief ݂PIO̓o͏Ԃ擾܂
* @return ݂PIȌ(2byte܂߂ׂ)
* @retval -1(0xFFFF) ʐMs
* @details Move߂gČ݂PIO̓͂o͂擾܂
* @note Ήbit́@1:ó@0:
* @attention 1bitłȂ̂Œ
**/	
unsigned short Rcb4BaseClass::getPioMode()
{
	byte	wkbuf[10];
	if(moveRamToComCmdSynchronize(PioModeAddres ,0x02,wkbuf) != 0xffff)
	{
		WordByte wk;
		wk.byte[0] = wkbuf[0];
		wk.byte[1] = wkbuf[1];

		wk.word &= 0x03FF;		//Ȃbit̓}XN

		return 	wk.word;	
	}
	else
	{
		return 0xffff;
	}
}


//PIO̓o͂̎wύX)
/**
* @brief ݂PIO̓o͏ԂύX܂
* @param[in] pioModeData	PIOŜ̓o̓f[^
* @return ʐMǂ
* @retval False ʐMs
* @details Move߂gČ݂PIO͂Əo͂ύX܂
* @note Ήbit́@1:ó@0:
* @attention 1bitύXłȂ̂Œ
**/
bool Rcb4BaseClass::setPioMode (unsigned short pioModeData)
{
	return moveComToRamCmdSynchronize(PioModeAddres, (byte*)&pioModeData,2);
}



//////////////////////////////////////////////////////////////////////////////////////////
//AD֌W
//AD̏Ԃ擾
/**
* @brief ݎw肵AD̒l擾܂
* @param[in] adPort	AD|[g̎w(0`10)
* @return w肵AD̒l(\10bit)
* @retval -1(0xFFFF) ʐMs
* @details Move߂gĎw肵݂ADl擾܂
* @note	 AD0擾ƌ݂̓ddl𕪈lǂ߂܂
**/	
unsigned short Rcb4BaseClass::getAdData(int adPort)
{
	byte	wkbuf[10];
	if(moveRamToComCmdSynchronize(AdcRamAddress + adPort * 2 ,0x02,wkbuf) != 0xffff)
	{
		WordByte wk;
		wk.byte[0] = wkbuf[0];
		wk.byte[1] = wkbuf[1];
		
		return 	wk.word;
	}
	else
	{
		return 0xffff;
	}

}

//ׂĂAD̏Ԃ擾
/**
* @brief ݂AD̒lׂĂ擾܂
* @param[out] adDatas[] ׂĂADli[z
* @return ʐMǂ
* @retval False ʐMs
* @details Move߂gĎw肵݂ADl擾܂
* @note	 AD0擾ƌ݂̓ddl𕪈lǂ߂܂
* @attention adDatas[]11̔zɗpӂĂ
**/
bool Rcb4BaseClass::getAllAdData(int	adDatas[])
{
	byte	wkbuf[30];
	
	if(moveRamToComCmdSynchronize(AdcRamAddress  ,AdcDataCount ,wkbuf) != 0xffff)
	{
		int	*iptr = (int*)&wkbuf;
		
		for(int i = 0; i < AdcCount; i++)
		{
			adDatas[i] = *iptr++;
		}
		return 	true;
	}
	else
	{
		return false;
	}
}

//////////////////////////////////////////////////////////////////////////////////////////
//{^f[^𑗕t
//KRRׂ̂Ẵf[^ݒ肷
/**
* @brief KRR̗̈Ƀf[^ׂđM(^IɃ{^f[^𑗂)
* @param[in] buttonData {^f[^
* @param[in] adData 4bytẽAiOf[^w
* @return ʐMǂ
* @retval False ʐMs
* @details Move߂gKRR̗̈Ƀf[^ׂđM܂
* @note	 {^f[^RCB4ɂ܂B
* @note	Tv[V{^gKɂĂ郂[V𓮂Ɏgp܂
* @note	{^ĂȂԂ܂ŉςȂɂȂ܂
* @attention RCB4KRRڑȂł
**/
bool Rcb4BaseClass::setKrrData (unsigned short buttonData, byte adData[])
{
	byte	wk[6];
	WordByte wwk;

	wwk.word = buttonData;

	wk[0] = wwk.byte[0];
	wk[1] = wwk.byte[1];
	memcpy(&wk[2],adData,4);
	return moveComToRamCmdSynchronize(KrrButtonDataAddress, wk,6);
}



//KRR̃{^f[^ݒ肷
/**
* @brief KRR̗̈Ƀ{^f[^𑗐M(^IɃ{^f[^𑗂)
* @param[in] buttonData {^f[^
* @return ʐMǂ
* @retval False ʐMs
* @details Move߂gKRR̗̈Ƀ{^f[^𑗐M܂
* @note	{^f[^RCB4ɂ܂B
* @note	Tv[V{^gKɂĂ郂[V𓮂Ɏgp܂
* @note	{^ĂȂԂ܂ŉςȂɂȂ܂
* @attention RCB4KRRڑȂł
**/
bool Rcb4BaseClass::setKrrButtonData (unsigned short buttonData)
{
	byte wk[2];
	
	WordByte wwk;

	wwk.word = buttonData;
	
	wk[0] = wwk.byte[1];
	wk[1] = wwk.byte[0];			//{^f[^̓vO猩ƋtɔzuĂ
	
	return moveComToRamCmdSynchronize(KrrButtonDataAddress, wk,2);
}

//KRRAD̃f[^ݒ肷)
/**
* @brief KRR̗̈Ƀ{^f[^𑗐M(^IɃ{^f[^𑗂)
* @param[in] paPort w肷AD|[g(1`4)
* @param[in] adData ADf[^(7bit)
* @return ʐMǂ
* @retval False ʐMs
* @details Move߂gKRRADf[^𑗐M܂
* @note	 KRRɎMĂAD̗̈Ƀf[^ɂ܂B
* @note	 KRRADlgă[VύXĂꍇɊOύXł܂
* @attention RCB4KRRڑȂł
**/
bool Rcb4BaseClass::setKrrAdData (byte paPort, byte adData)
{
	byte	wk[2];

	wk[0] =  adData;
	return moveComToRamCmdSynchronize(KrrPa1Address + (paPort - 1), wk,1);

}



//////////////////////////////////////////////////////////////////////////////////////////
//T[{[^
//T[{[^P̂𓮂
/**
* @brief w肵T[{[^P̂𓮍삳܂
* @param[in] id		T[{[^IDԍ
* @param[in] sio	SIO̒l(SioNum)
* @param[in] pos	T[{[^̖ڕW|WVl
* @param[in] frame	t[(قǂ蓮)
* @return ʐMǂ
* @retval False ʐMs
* @details w肵T[{[^ID,SIO,POS,Framegpē܂
* @note	 [VĐɎw肵ꍇ̓[V̊pxf[^D悳܂
**/
bool Rcb4BaseClass::setSingleServo (byte id, byte sio,int pos,byte frame)
{
	if(runSingleServoCmd(id, sio, pos, frame) == -1)	return false;
	return	SynchronizeAck(txBuf);
}



/**
* @brief w肵T[{[^P̂𓮍삳܂
* @param[in] servoData		T[{[^̃f[^ЂƂ܂ɂ
* @param[in] frame	t[(قǂ蓮)
* @return ʐMǂ
* @retval False ʐMs
* @details servoDataɓĂT[{[^̏Ƃ,Framegpē܂
* @note	 [VĐɎw肵ꍇ̓[V̊pxf[^D悳܂
**/
bool Rcb4BaseClass::setSingleServo (ServoData servoData,byte frame)
{
	if(runConstFrameServoCmd(&servoData, 1, frame) == -1)	return false;
	return	SynchronizeAck(txBuf);
}



/**
* @brief w肵T[{[^P̂t[ɂ܂
* @param[in] id		T[{[^ID
* @param[in] sio	SIO̒l(SioNum)
* @return ʐMǂ
* @retval False ʐMs
* @details ID,SIOŎw肵T[{[^t[ɂ܂
* @attention	 Freew肷Hold̃R}hs܂FreeԂۂ܂
**/
bool Rcb4BaseClass::setFreeSingleServo (byte id, byte sio)
{
	if(runSingleServoCmd(id, sio, 0x8000, 1) == -1)	return false;
	return	SynchronizeAck(txBuf);
}



/**
* @brief w肵T[{[^P̂ɃgN܂
* @param[in] id		T[{[^ID
* @param[in] sio	SIO̒l(SioNum)
* @return ʐMǂ
* @retval False ʐMs
* @details ID,SIOŎw肵T[{[^ɃgN܂
			FreeԂgNԂɕA܂
* @note	 Freew肷Hold̃R}hs܂FreeԂۂ܂
**/
bool Rcb4BaseClass::setHoldSingleServo (byte id, byte sio)
{
	if(runSingleServoCmd(id, sio, 0x7FFF, 1) == -1)	return false;
	return	SynchronizeAck(txBuf);
}



//w肵̃T[{[^𓮂)
/**
* @brief w肵T[{[^𓮍삳܂
* @param[in] servoDatas[]		T[{[^̃f[^ЂƂ܂ɂ̂𕡐
* @param[in] servoCount servoDatas̃T[{̐
* @param[in] frame	t[(قǂ蓮)
* @return ʐMǂ
* @retval False ʐMs
* @details servoDataɓĂ镡̃T[{[^̏ƂFramegpē܂
* @note	 [VĐɎw肵ꍇ̓[V̊pxf[^D悳܂
**/
bool Rcb4BaseClass::setServoPos (ServoData servoDatas[],byte servoCount,byte frame)
{
	if(runConstFrameServoCmd(servoDatas, servoCount, frame) == -1)	return false;
	return	SynchronizeAck(txBuf);
}

//w肵̃T[{[^t[ɂ
/**
* @brief w肵T[{[^P̂t[ɂ܂
* @param[in] servoDatas[]		T[{[^̃f[^ЂƂ܂ɂ̂𕡐
* @param[in] servoCount servoDatas̃T[{̐
* @return ʐMǂ
* @retval False ʐMs
* @details servoDatas[]Ŏw肵T[{[^t[ɂ܂
* @attention	 Freew肷Hold̃R}hs܂FreeԂۂ܂
* @attention	 servoDatasData0x8000ɏ܂
**/
bool Rcb4BaseClass::setFreePos (ServoData servoDatas[],byte servoCount)
{
	for(int i = 0; i < servoCount; i++)
	{
		servoDatas[i].Data = 0x8000;
	}
	return	setServoPos (servoDatas, servoCount, 1);
}



/**
* @brief w肵̃T[{[^ɃgN܂
* @param[in] servoDatas[]		T[{[^̃f[^ЂƂ܂ɂ̂𕡐
* @param[in] servoCount servoDatas̃T[{̐
* @return ʐMǂ
* @retval False ʐMs
* @details servoDatas[]Ŏw肵T[{[^t[ɂ܂
			FreeԂgNԂɕA܂
* @note	 Freew肷Hold̃R}hs܂FreeԂۂ܂
* @attention	 servoDatasData0x7FFFɏ܂
**/
bool Rcb4BaseClass::setHoldPos (ServoData servoDatas[],byte servoCount)
{
	for(int i = 0; i < servoCount; i++)
	{
		servoDatas[i].Data = 0x7FFF;
	}
	return	setServoPos (servoDatas, servoCount, 1);
}



//w肵T[{[^̃|WVf[^擾
/**
* @brief w肵T[{[^̃|WVf[^擾܂
* @param[in] id		T[{[^ID
* @param[in] sio	SIO̒l(SioNum)
* @return w肵T[{[^̃|WVf[^
* @retval -1 ʐMs
* @details ID,SIOŎw肵T[{[^̃|WVf[^擾܂
**/
int Rcb4BaseClass::getSinglePos(byte id,byte sio)
{
	if(moveDeviceToComCmd(id,sio, MotorPositionAddressOffset, 2) == -1)	return -1;
	if(synchronize(txBuf, txBuf[0], rxBuf, 5) == true)
	{
		WordByte	wk;
		wk.byte[0] = rxBuf[2];
		wk.byte[1] = rxBuf[2];
		return wk.word;
	}
	else
	{
		return -1;
	}
}

//w肵T[{[^̃Xs[hύX
/**
* @brief w肵T[{[^̃Xs[hύX܂
* @param[in] servoDatas[]		T[{[^̃f[^ЂƂ܂ɂ̂𕡐
* @param[in] servoCount servoDatas̃T[{̐
* @return ʐMǂ
* @retval False ʐMs
* @details servoDatas[]Ŏw肵T[{[^̃Xs[h(o͂̏l)ύX܂
* @note	 servoDatasDataɂ̓Xs[hl܂
**/
bool Rcb4BaseClass::setServoSpeed (ServoData servoDatas[],byte servoCount)
{
	
	if(setSpeedCmd(servoDatas, servoCount) == -1)	return false;
	return	SynchronizeAck(txBuf);
}



//w肵T[{[^̃Xgb`ύX
/**
* @brief w肵T[{[^̃Xgb`ύX܂
* @param[in] servoDatas[]		T[{[^̃f[^ЂƂ܂ɂ̂𕡐
* @param[in] servoCount servoDatas̃T[{̐
* @return ʐMǂ
* @retval False ʐMs
* @details servoDatas[]Ŏw肵T[{[^̃Xgb`(_炩)ύX܂
* @note	 servoDatasDataɂ̓Xgb`l܂
**/
bool Rcb4BaseClass::setServoStretch (ServoData servoDatas[],byte servoCount)
{
	
	if(setStretchCmd(servoDatas, servoCount) == -1) return false;
	return	SynchronizeAck(txBuf);

}

//IDSIOICSԍɕϊ
/**
* @brief IDSIO̔ԍICSԍɕύX܂
* @param[in] id		T[{[^ID
* @param[in] sio	SIO̒l(SioNum)
* @return ICSԍ
* @details IDSIO̔ԍRCB4ňICSԍɕύX܂
**/
byte Rcb4BaseClass::icsNum2id(byte id,byte sio)
{
	return id * 2 + (sio - 1);
}

//////////////////////////////////////////////////////////////////////////////////////////
//T[{[^

//w肵[VĐ
/**
* @brief w肵[VĐ܂
* @param[in] motionNum		Đ郂[Vԍ
* @return ʐMǂ
* @retval False ʐMs
* @details w肵[VĐ܂
* @note		suspend() => resetProgramCounter() => setMotionNum() => resume() 
* @note		ꎞf  => vOJE^Zbg => [VAhXɃWv => [V̍ĊJ
			̎菇Ń[VĐ܂
* @attention	݁Ã[VĐłIɎ~߂ĂĐ܂
**/
bool Rcb4BaseClass::motionPlay(int motionNum)
{
	
	if(suspend() == false)	return false;
	
	if(resetProgramCounter() == false)	return false;
	
	if(setMotionNum(motionNum) == false)	return false;
	
	return resume ();
}



//[Vꎞ~
/**
* @brief [Vꎞ~܂
* @return ʐMǂ
* @retval False ʐMs
* @details [Vꎞ~܂
* @note		mɂ́AVXeWX^EnableRunEepromlύX܂
				xN^Wv𖳌Ė@Ȃǂ̃{^f[^ŃWv̂߂܂
* @attention	݁Ã[VĐłIɎ~߂܂
* @attention	configDatal𒼐ڕς܂̂ŁAӂKvł
**/
bool Rcb4BaseClass::suspend()
{
	return suspend(&(configData.word));
}



/**
* @brief [Vꎞ~܂
* @param[in,out] config		OŊoĂconfigf[^
* @return ʐMǂ
* @retval False ʐMs
* @details [Vꎞ~܂
* @note		mɂ́AVXeWX^EnableRunEepromlύX܂
				xN^Wv𖳌Ė@Ȃǂ̃{^f[^ŃWv̂߂܂
* @attention	݁Ã[VĐłIɎ~߂܂
* @attention	config𒼐ڕς܂̂ŁAӂKvł
**/
bool Rcb4BaseClass::suspend(unsigned short *config)
{
	ConfigData *cData = (ConfigData *)config;
	
	cData->bit.EnableRunEeprom =0;			//EEPROMŎs̕~߂
	//configData.bit.EnableServoResponse = 0;		//T[{̃X|XԂȂ
	cData->bit.EnableReferenceTable = 0;	//xN^Wv𖳌ɂ
	//configData.bit.EnableSio = 1;				//SIO͓܂܂ɂ
	
	return moveComToRamCmdSynchronize(ConfigRamAddress, (byte*)config,2);
	

}



//ROM̃[VAhXɔ
/**
* @brief w肵[VɃWv܂
* @param[in] motionNum		Wv郂[Vԍ
* @return ʐMǂ
* @retval False ʐMs
* @details vOJE^Zbg܂B
* @note		CALL߂Ŏw[V̐擪AhXɃWv܂
* @attention	݁Ã[VĐłIɃWv̂ŒӂKvł
**/
bool Rcb4BaseClass::setMotionNum(byte motionNum)
{
	if(callCmd(txBuf	,motionAddr2motionNum(motionNum)) == -1) return false;
	return SynchronizeAck(txBuf);
}



//vtJE^Zbg܂
/**
* @brief vtJE^Zbg܂
* @return ʐMǂ
* @retval False ʐMs
* @details vOJE^Zbg܂B
* @note		vOJE^RCB4ݒ̃AhXɈړ܂B
			܂AEEPROMXVtO0ɂĂ܂
* @attention	݁Ã[VĐłIɕς܂̂ŁAӂKvł
**/
bool Rcb4BaseClass::resetProgramCounter()
{
	WordByte wwk;
	byte	wk[10];

	wwk.word = MainLoopCmd;
	memset(wk,0x00,10);
	wk[0] = wwk.byte[0];  
	wk[1] = wwk.byte[1]; 
	return moveComToRamCmdSynchronize(ProgramCounterRamAddress, wk,10);
}



//[VX^[g(A)܂
/**
* @brief [VĊJ܂
* @return ʐMǂ
* @retval False ʐMs
* @details [Vꎞ~܂
* @note		mɂ́AVXeWX^EnableRunEepromlύX܂
				xN^WvLĖ@Ȃǂ̃{^f[^ŃWvł悤ɂ܂
* @attention	݁Ã[VĐłIɎ~߂܂
* @attention	configDatal𒼐ڕς܂̂ŁAӂKvł
**/
bool Rcb4BaseClass::resume ()
{
	return resume(&(configData.word));
}



/**
* @brief [VĊJ܂
* @param[in,out] config		OŊoĂconfigf[^
* @return ʐMǂ
* @retval False ʐMs
* @details [Vꎞ~܂
* @note		mɂ́AVXeWX^EnableRunEepromlύX܂
				xN^WvLĖ@Ȃǂ̃{^f[^ŃWvł悤ɂ܂
* @attention	config𒼐ڕς܂̂ŁAӂKvł
**/
bool Rcb4BaseClass::resume (unsigned short *config)
{
	ConfigData *cData = (ConfigData *)config;
	
	cData->bit.EnableRunEeprom =1;			//EEPROM̓ǂݍݓX^[g
	//configData.bit.EnableServoResponse = 0;		//T[{̃X|XԂȂ
	cData->bit.EnableReferenceTable = 1;	//xN^WvLɂ
	//configData.bit.EnableSio = 1;				//SIO͓܂܂ɂ
	
	return moveComToRamCmdSynchronize(ConfigRamAddress, (byte*)config,2);
	
}



//[Vԍ[V̐擪AhXɕϊ
/**
* @brief [Vԍ烂[V̐擪AhX߂܂
* @return [Vԍ̐擪̃AhX
* @details [Vԍ烂[V̐擪AhX߂܂
* @note		AhXɊւĂRCB-4vO~O}jAB
* @attention	[VAhX́AHTH4V2.2ȍ~̃AhXɂȂ܂B
* @attention	V2.0ȑÕAhXł͌듮܂̂ŒӂKvł
**/
long Rcb4BaseClass::motionAddr2motionNum(byte motionNum)
{
	//return (motionNum -1)* MotionSingleDataCount + MotionRomAddress;
	return (long)(motionNum -1)* (long)MotionSingleDataCount + MotionRomAddress;
}



















